# app/presenters/user_presenter.rb
class UserPresenter
  attr_reader :address, :user

  delegates :city, :state, :street, :zip_code,
          to: :address

  def initialize(user, template)
    @user, @template = user, template
    @address = user.address
  end

  def linked_name
    link_to_if user.url.present?,
      "#{user.first_name} #{user.last_name}", user.url
  end

  # dynamic proxy to delegate methods to the template
  def method_missing(*args, &block)
    @template.send(*args, &block)
  end
end
